import type Pipe from "./pipe.js";
import type { Options } from "./types";
import type { Context, DiffContext, PatchContext } from "./contexts";
declare class Processor {
    selfOptions: Options;
    pipes: {
        diff: Pipe<DiffContext>;
        patch: Pipe<PatchContext>;
    };
    constructor(options?: Options);
    options(options?: Options): Options;
    pipe<TContext extends Context<any>>(name: string | Pipe<TContext>, pipeArg?: Pipe<TContext>): Pipe<DiffContext> | Pipe<PatchContext> | Pipe<TContext>;
    process<TContext extends Context<any>>(input: TContext, pipe?: Pipe<TContext>): TContext["result"] | undefined;
}
export default Processor;
